class PathsMapper expands KeyPoint;

var PathsActor G;
var Actor HackedZone;
var Shoot_It Shooter;
var NavigationPoint N1, N2, N3, N4, N5, N6, N7, N8, N9, N10, N11, N12, N13, N14; //Asiggning points to connect

/*
,'BirdBrainedResearch'
*/

/*
	This Keypoint is not compiled normally due to Navigation tunes requested. This is method for nasty low grav zones.
	Bot attempt to wander randomly blocking those teleporters and wasting time useless.
	KeyPoint Patcher will lock them as much as possible.
	We need also some links which doesn't exist.
	Several combat zones need Teleporters higher or else bot wuill telefrag any pawn - seriously that setup looks EVIL.
	Movers - WTF is here anyway, majority can be open with GRAB command - gimme a break.
	Mover in sniper zones what purpose do has that ? From now on it will open and we can get those dropped weapons
	by boosting up. Combat is balanced, they have Insta, we have Insta LOL.
	Not the last, PrecipitationGenerator sucks - it won't live that much.
*/

//=====
native(1718) final function bool AddToPackageMap( optional string PkgName );
//=====
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly ); //Second parameter doesn't exist in 227!
//=====
native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt );
//=====
native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible );
//=====
native(3542) final iterator function InventoryActors( class<Inventory> InvClass,
out Inventory Inv, optional bool bSubclasses, optional Actor StartFrom );
//=====
native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor, float Radius,
optional vector Loc );
//=====
native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );
//=====
native(3560) static final function bool ReplaceFunction( class<Object> ReplaceClass,
class<Object> WithClass, name ReplaceFunction, name WithFunction, optional name InState );
//=====

event PreBeginPlay()
{
	log(Self.name@"Patching Level.",'BirdBrainedResearch');
	G = Spawn( class'PathsActor' );
	ChangeNastyActors();
	AddMHObjectives();
	DoAlterBadPoints();
	SpawnShoters();
	InitialState='PathsMapping';
	log ("PreBeginPlay Completed...",'BirdBrainedResearch');
}

event PostBeginPlay()
{
}

final function SpawnShoters()
{
	local Shoot_It Shooter;

	Shooter = Spawn(class'Shoot_It');
	if ( Shooter != None )
	{
		Shooter.AName = "CHair7";
		Shooter = None;
	}
	Shooter = Spawn(class'Shoot_It',,,vect(-12672,9006,-2782));
	if ( Shooter != None )
	{
		Shooter.AName = "WoodenBox0";
		Shooter = None;
	}
}

function AddMHObjectives()
{
	local class<Actor> Wp;
	local Actor K1, K2, K3, K4, K5, K6, K7, K8, K9, K10, K11, K12, K13;
	local Actor tmp;


	Wp = class<Actor>(DynamicLoadObject("MonsterHunt.MonsterWayPoint",class'Class',True));
	if ( Wp != None )
	{
		WP.Default.bGameRelevant = True;
		K1 = Spawn(Wp,,,vect(-1295,-98,-211)); //Minigun
		if ( K1 != None )
			log (K1.Name@"spawned at"@K1.Location,'BirdBrainedResearch');
		K2 = Spawn(Wp,,,vect(-2264,392,296)); //Ripper
		if ( K2 != None )
		{
			K2.SetPropertyText("Position","2");
			log (K2.Name@"spawned at"@K2.Location,'BirdBrainedResearch');
		}
		K3 = Spawn(Wp,,,vect(1524,480,-1102)); //Button Krall
		if ( K3 != None )
		{
			K3.SetPropertyText("Position","3");
			K3.SetPropertyText("TriggerEvent1","KrallGuardianFactory");
			K3.PostBeginPlay(); //lol
			log (K3.Name@"spawned at"@K3.Location,'BirdBrainedResearch');
			log (K3.Name@"will trigger"@K3.GetPropertyText("TriggerActor1"),'BirdBrainedResearch');
		}
		K4 = Spawn(Wp,,,vect(179,480,-1128)); //KrallGuardian finished - keep coming here
		if ( K4 != None )
		{
			K4.SetPropertyText("Position","4");
			log (K4.Name@"spawned at"@K4.Location,'BirdBrainedResearch');
		}
		K5 = Spawn(Wp,,,vect(-8384,5848,-2336)); //Rainbows teleports - Must block this
		if ( K5 != None )
		{
			tmp = Spawn(class'TouchProtector',,,vect(-8384,5848,-2338));
			tmp.Tag = 'teleplatform';
			log (tmp.Name$" has Tag "$tmp.Tag,'BirdBrainedResearch');
			tmp = None;
			K5.SetPropertyText("Position","5");
			log (K5.Name@"spawned at"@K5.Location,'BirdBrainedResearch');
		}
		K6 = Spawn(Wp,,,vect(-8556,6986,-3218)); //Rainbows low - must kill them all
		if ( K6 != None )
		{
			K6.SetPropertyText("Position","6");
			log (K6.Name@"spawned at"@K6.Location,'BirdBrainedResearch');
		}
		K7 = Spawn(Wp,,,vect(-9084,9012,-2980)); //Behind slime cave nearby warp
		if ( K7 != None )
		{
			K7.SetPropertyText("Position","7");
			log (K7.Name@"spawned at"@K7.Location,'BirdBrainedResearch');
		}
		K8 = Spawn(Wp,,,vect(-8442,-4782,-3552)); //Experiment destruction button 
		if ( K8 != None )
		{
			K8.SetPropertyText("Position","8");
			K8.SetPropertyText("TriggerEvent1","zipzapse490");
			K8.PostBeginPlay();
			log (K8.Name@"spawned at"@K8.Location,'BirdBrainedResearch');
			log (K8.Name@"will trigger"@K8.GetPropertyText("TriggerActor1"),'BirdBrainedResearch');
		}
		K9 = Spawn(Wp,,,vect(-9168,20288,-3524)); //Mantas, eh door
		if ( K9 != None )
		{
			tmp = Spawn(class'TouchProtector',,,vect(-9168,20288,-3522));
			tmp.Tag = 'gooeyfooeymant';
			log (tmp.Name$" has Tag "$tmp.Tag,'BirdBrainedResearch');
			tmp = None;
			K9.SetPropertyText("Position","9");
			log (K9.Name@"spawned at"@K9.Location,'BirdBrainedResearch');
		}
		K10 = Spawn(Wp,,,vect(-7628,25714,-3584)); //Warlords - it needs to be protected
		if ( K10 != None )
		{
			tmp = Spawn(class'TouchProtector',,,vect(-7628,25714,-3583));
			tmp.Tag = 'warloosaze';
			log (tmp.Name$" has Tag "$tmp.Tag,'BirdBrainedResearch');
			tmp = None;
			K10.SetPropertyText("Position","10");
			log (K10.Name@"spawned at"@K10.Location,'BirdBrainedResearch');
		}
		K11 = Spawn(Wp,,,vect(-12400,9236,-3054)); //Opening Tentacles after battling
		if ( K11 != None )
		{
			K11.SetPropertyText("Position","11");
			K11.SetPropertyText("TriggerEvent1","carnivaltent23");
			K11.PostBeginPlay();
			log (K11.Name@"spawned at"@K11.Location,'BirdBrainedResearch');
			log (K11.Name@"will trigger"@K11.GetPropertyText("TriggerActor1"),'BirdBrainedResearch');
		}
		K12 = Spawn(Wp,,,vect(-13212,12570,-2098)); //battling room with pupaes before howercraft
		if ( K12 != None )
		{
			K12.SetPropertyText("Position","12");
			log (K12.Name@"spawned at"@K12.Location,'BirdBrainedResearch');
		}
		K13 = Spawn(Wp,,,vect(-13484,-27972,-2069)); //Door nearby Madmerc
		if ( K13 != None )
		{
			K13.SetPropertyText("Position","13");
			log (K13.Name@"spawned at"@K13.Location,'BirdBrainedResearch');
		}
	}
	else
	{
		log ("Did not find class MonsterWayPoint for objectives.",'BirdBrainedResearch');
	}
}

function DoAlterBadPoints()
{
	local NavigationPoint A;
	local InventorySpot Is;
	local JumpSpot Js;
	local LiftExit Le;
	local Teleporter Tl;
	local PathNode Pt;
	local int I;
	local string st;

//	for ( A=Level.NavigationPointList; A!=None; A=A.NextNavigationPoint )

//	foreach NavigationActors(class 'NavigationPoint', A)
//	{
		log ("Attempting to screw up 45 NavigationPoint actors...",'BirdBrainedResearch');
		if ( G != None )
		{
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-12620,8959,-2615 ) )
			{
				if ( string(Is.Name) ~= "InventorySpot132" ) //WarFlakCannon - not navigable
				{
					//RemovePaths(Is);
					G.CleanupNavSpecs(Is);
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(17510,-8416,-2878 ) )
			{
				if ( string(Is.Name) ~= "InventorySpot131") //BerserkStinger - not navigable
				{
					//RemovePaths(Is);
					G.CleanupNavSpecs(Is);
					Is.ExtraCost = 100000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None; 
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-8288,24342,-3504) )
			{
				if ( string(Is.Name) ~= "InventorySpot83") //This is an UDamage - do not look for this if no combat
				{
					//RemovePaths(Is);
					G.CleanupNavSpecs(Is);
					Is.ExtraCost = 100000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(17632,-4464,-3231) )
			{
				if ( string(Is.Name) ~= "InventorySpot49") //This is Redeemer - Not a goal
				{
					//RemovePaths(Is);
					G.CleanupNavSpecs(Is);
					Is.bStatic = False;
					Is.ExtraCost = 100000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					Is.SetLocation(Is.Location+vect(0,0,-85));
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(134,-422,-228) )
			{
				if ( string(Is.Name) ~= "InventorySpot19") //PulseGun covered, Bot going retarded on that spot
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost = 100000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(392,430,-222) )
			{
				if ( string(Is.Name) ~= "InventorySpot17") // ShockRifle - unreachable without unlocking
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 60, vect(-13008,9240,-3040) )
			{
				if ( string(Is.Name) ~= "InventorySpot16")
				{
					Is.bStatic = False;
					Is.SetLocation(vect(-13008,9240,-3040));
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(168,428,-230) )
			{
				if ( string(Is.Name) ~= "InventorySpot11")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(278,430,-224) )
			{
				if ( string(Is.Name) ~= "InventorySpot9")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-96,428,-224) )
			{
				if ( string(Is.Name) ~= "InventorySpot7")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-1274,-64,-218) )
			{
				if ( string(Is.Name) ~= "InventorySpot5")
				{
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-202,-110,-230) )
			{
				if ( string(Is.Name) ~= "InventorySpot4")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-226,126,-224) )
			{
				if ( string(Is.Name) ~= "InventorySpot2")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-208,22,-230) )
			{
				if ( string(Is.Name) ~= "InventorySpot1")
				{
					Is.bStatic = False;
					Is.SetLocation(Is.Location+vect(0,0,-180));
					Is.ExtraCost=10000000;
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					Is.bStatic = True;
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
			foreach NavigationActors( class 'InventorySpot', Is, 40, vect(-2254,352,307) )
			{
				if ( string(Is.Name) ~= "InventorySpot0")
				{
					Is.MarkedItem.MyMarker = None;
					Is.MarkedItem = None;
					G.CleanupNavSpecs(Is);
					I++;
					log (Is.Name@"is number"@I);
					break;
				}
			}
//---- PathNodes setup - fixing stupid heights and assign future connections by declaring variables here

			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13440,-32020,-1822) )
			{
				if ( string(Pt.Name) ~= "PathNode218")
				{
					I++;
					log (Pt.Name@"is number"@I);
					Pt.bStatic = False;
					Pt.SetLocation(vect(-13470,-32020,-1822));
					Pt.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13484,-29650,-1816) )
			{
				if ( string(Pt.Name) ~= "PathNode210") //Levitating or something ?
				{
					I++;
					log (Pt.Name@"is number"@I);
					Pt.bStatic = False;
					Pt.SetLocation(Pt.Location + vect(0,0,-50));
					N12 = Pt;
					Pt.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13488,-29092,-1976) )
			{
				if ( string(Pt.Name) ~= "PathNode209") 
				{
					I++;
					log (Pt.Name@"is number"@I);
					N11 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13492,-28004,-2058) )
			{
				if ( string(Pt.Name) ~= "PathNode180")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N14 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13492,-27344,-2058) )
			{
				if ( string(Pt.Name) ~= "PathNode179")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N13 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-13498,12296,-2156) )
			{
				if ( string(Pt.Name) ~= "PathNode124")
				{
					I++;
					log (Pt.Name@"is number"@I);
					Pt.bStatic = False;
					Pt.SetLocation(Pt.Location+vect(0,0,20));
					Pt.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(80,32,-178) )
			{
				if ( string(Pt.Name) ~= "PathNode78")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N4 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-9674,24660,-3380) )
			{
				if ( string(Pt.Name) ~= "PathNode70") //acquire this as target for that dumb placed... with relocating it
				{
					I++;
					log (Pt.Name@"is number"@I);
					N8 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-10138,24212,-3362) )
			{
				if ( string(Pt.Name) ~= "PathNode65") //Whatta heck is this ? And... connect it with no. 70
				{
					I++;
					log (Pt.Name@"is number"@I);
					Pt.bStatic = False;
					Pt.SetLocation(vect(-10124,24260,-3416));
					N7 = Pt;
					Pt.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-10146,23198,-3424) )
			{
				if ( string(Pt.Name) ~= "PathNode63")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N6 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-10282,23128,-3480) )
			{
				if ( string(Pt.Name) ~= "PathNode62")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N5 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-9456,20288,-3498) )
			{
				if ( string(Pt.Name) ~= "PathNode53")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N10 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-9184,20288,-3514) )
			{
				if ( string(Pt.Name) ~= "PathNode42")
				{
					I++;
					log (Pt.Name@"is number"@I);
					N9 = Pt;
					break;
				}
			}
			foreach NavigationActors( class'PathNode', Pt, 40, vect(-8606,7004,-2538) )
			{
				if ( string(Pt.Name) ~= "PathNode15")
				{
					I++;
					log (Pt.Name@"is number"@I);
					Pt.bStatic = False;
					Pt.SetLocation(vect(-8588,7022,-2538));
					N1 = Pt;
					Pt.bStatic = True;
					break;
				}
			}

//LiftExit types - dumb paths - preparing other forced links

			foreach NavigationActors( class'LiftExit', Le, 40, vect(-8552,6526,-2316) )
			{
				if ( string(Le.Name) ~= "LiftExit5")
				{
					I++;
					log (Le.Name@"is number"@I);
					Le.bStatic = False;
					Le.SetLocation(vect(-8552,6366,-2194));
					Le.ExtraCost = 100000000;
					G.CleanupNavSpecs(Le);
					Le.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'LiftExit', Le, 40, vect(-8572,7110,-2960) )
			{
				if ( string(Le.Name) ~= "LiftExit3")
				{
					I++;
					log (Le.Name@"is number"@I);
					N2 = Le;
					break;
				}
			}


			foreach NavigationActors( class'JumpSpot', Js, 40, vect(-8554,6464,-2316) )
			{
				if ( string(Js.Name) ~= "JumpSpot1")
				{
					I++;
					log (Js.Name@"is number"@I);
					Js.SetLocation(vect(-8612,6304,-2314));
					Js.ExtraCost = 100000000;
					G.CleanupNavSpecs(Js);
					break;
				}
			}

// Teleporters - lost Bot probably will block them (happened not once)
// - I will not only destroy routes but I'll ruin them for A.I....

			foreach NavigationActors( class'Teleporter', Tl, 40, vect(336,-570,-144) )
			{
				if ( string(Tl.Name) ~= "Teleporter48" )
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.ExtraCost = 100000000;
					Tl.SetCollisionSize(18,Tl.CollisionHeight);
					G.CleanupNavSpecs(Tl);
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-13490,-27832,-2052) )
			{
				if ( string(Tl.Name) ~= "Teleporter47" )
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,110));
					G.CleanupNavSpecs(Tl);
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(17816,-4480,-3238) )
			{
				if ( string(Tl.Name) ~= "Teleporter46" )
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.ExtraCost = 100000000;
					G.CleanupNavSpecs(Tl);
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(142,-582,-198) )
			{
				if ( string(Tl.Name) ~= "Teleporter22" )
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.ExtraCost = 100000000;
					G.CleanupNavSpecs(Tl);
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-90,596,-198) )
			{
				if ( string(Tl.Name) ~= "Teleporter21")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.ExtraCost = 100000000;
					G.CleanupNavSpecs(Tl);
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(290,600,-198) )
			{
				if ( string(Tl.Name) ~= "Teleporter20")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.ExtraCost = 100000000;
					G.CleanupNavSpecs(Tl);
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-9372,20288,-3472) )
			{
				if ( string(Tl.Name) ~= "Teleporter18")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,70));
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-6474,20286,-3500) )
			{
				if ( string(Tl.Name) ~= "Teleporter15")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,70));
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-8408,6994,-2538) )
			{
				if ( string(Tl.Name) ~= "Teleporter13")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,80));
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(1238,62,-184) )
			{
				if ( string(Tl.Name) ~= "Teleporter3")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,80));
					Tl.SetPropertyText("URL",""); //I intend to unlock paths through teleporters with no target URL - some of these are needed free
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(338,1250,-238) )
			{
				if ( string(Tl.Name) ~= "Teleporter2")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,70));
					Tl.SetPropertyText("URL","");;
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(-2340,568,270) )
			{
				if ( string(Tl.Name) ~= "Teleporter11")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(Tl.Location+vect(0,0,30));
					Tl.SetPropertyText("URL","");
					Tl.bStatic = True;
					break;
				}
			}
			foreach NavigationActors( class'Teleporter', Tl, 40, vect(216,24,122) )
			{
				if ( string(Tl.Name) ~= "Teleporter0")
				{
					I++;
					log (Tl.Name@"is number"@I);
					Tl.bStatic = False;
					Tl.SetLocation(vect(216,22,36));
					Tl.SetPropertyText("URL",""); //This is going to mess some stuff - heads nowhere anyway
					N3 = Tl;
					Tl.bStatic = True;
					break;
				}
			}

		}
//	} //old iterator close
}

function DoFakeNavigation()
{
	local RadiusMove RM0, RM1, RM2, RM3, RM4, RM5, RM6, RM7, RM8, RM9, RM10, RM11, RM12, RM13, RM14, RM15,
		RM16, RM17, RM18, RM19, RM20, RM21, RM22, RM23, RM24, RM25;
	local Dispatcher Ds0, Ds1, Ds2;

/* 
	Section Fake Navigation - DevPath is almost NONE here, probably XCGE does a bit of helping.
	As reward for my time wasted here I went to disable crapped sliding and stupid speed hacks...
	From now on we won't fall sliding.
*/
	RM0=Spawn(class'RadiusMove',,,vect(1306,5820,-2132));
	if ( RM0 != None )
	{
		RM0.RadiusRange=800;
		RM0.TimePush=2.000000;
		RM0.NamedActor="Teleporter30";
		RM0.Tag='1st_Radius';
		RM0 = None;
	}
	Ds0 = spawn(class'Dispatcher',,,vect(1306,5820,-2134)); //Trigger first radius
	if (Ds0 != None)
	{
		Ds0.Tag='fahfr371';
		Ds0.OutEvents[0]='1st_Radius';
	}
	Ds1 = spawn(class'Dispatcher',,,vect(1306,5820,-2136)); //Deactivate first radius if last teleporter is active
	if (Ds1 != None)
	{
		Ds1.Tag='warloosaze';
		Ds1.OutEvents[0]='1st_Radius'; //Deactivate first
		Ds1.OutEvents[1]='2nd_Radius'; //Activate last runner
	}
	RM1=Spawn(class'RadiusMove',,,vect(-7220,20326,-3438)); //guiding through ice caves
	if (RM1 != None)
	{
		RM1.RadiusRange=1600;
		RM1.TimePush=3.000000;
		RM1.NamedActor="PathNode42";
		RM1.bEnabled=True;
		RM1.Tag='UnUsed';
		RM1 = None;
	}
	RM2=Spawn(class'RadiusMove',,,vect(-9989,20294,-3366));
	if (RM2 != None)
	{
		RM2.RadiusRange=1200;
		RM2.TimePush=3.000000;
		RM2.NamedActor="PathNode55";
		RM2.bEnabled=True;
		RM2.Tag='UnUsed';
		RM2 = None;
	}
	RM3=Spawn(class'RadiusMove',,,vect(-10320,21584,-3420));
	if (RM3 != None)
	{
		RM3.RadiusRange=1350;
		RM3.TimePush=3.000000;
		RM3.NamedActor="PathNode63";
		RM3.bEnabled=True;
		RM3.Tag='UnUsed';
		RM3 = None;
	}
	RM4=Spawn(class'RadiusMove',,,vect(-10314,23558,-3312));
	if (RM4 != None)
	{
		RM4.RadiusRange=600;
		RM4.TimePush=2.000000;
		RM4.NamedActor="PathNode66";
		RM4.bEnabled=True;
		RM4.Tag='UnUsed';
		RM4 = None;
	}
	RM5=Spawn(class'RadiusMove',,,vect(-9790,24514,-3280));
	if (RM5 != None)
	{
		RM5.RadiusRange=850;
		RM5.TimePush=2.000000;
		RM5.NamedActor="PathNode71";
		RM5.bEnabled=True;
		RM5.Tag='UnUsed';
		RM5 = None;
	}
	RM6=Spawn(class'RadiusMove',,,vect(-8718,25280,-3324));
	if (RM6 != None)
	{
		RM6.RadiusRange=800;
		RM6.TimePush=5.000000;
		RM6.NamedActor="PathNode38";
		RM6.bEnabled=True;
		RM6.Tag='UnUsed';
		RM6 = None;
	}
	RM7=Spawn(class'RadiusMove',,,vect(-7902,25552,-3378)); //Activate this after killing warlords
	if (RM7 != None)
	{
		RM7.RadiusRange=900;
		RM7.TimePush=5.000000;
		RM7.NamedActor="Teleporter43";
		RM7.Tag='warloosaze';
		RM7 = None;
	}
/*
	Brute Corridor area also is a piece of shit as the rest of map
	Okay we have to spawn fake stuff
	After opening howercraft we have to activate some crap
*/
	RM8=Spawn(class'RadiusMove',,,vect(1306,5820,-2128)); //Here to setup others in the same time
	if ( RM8 != None )
	{
		RM8.RadiusRange=800;
		RM8.TimePush=1.500000;
		RM8.NamedActor="Teleporter33";
		RM8.Tag='2nd_Radius';
		RM8 = None;
	}
/*
	Ds1 = spawn(class'Dispatcher',,,vect(1306,5820,-2136)); //Deactivate first radius if last teleporter is active
	if (Ds1 != None)
	{
		Ds1.Tag='warloosaze';
		Ds1.OutEvents[0]='1st_Radius';
	}
*/
	RM9=Spawn(class'RadiusMove',,,vect(-12668,10158,-2912));
	if ( RM9 != None )
	{
		RM9.RadiusRange=800;
		RM9.TimePush=2.000000;
		RM9.NamedActor="Teleporter44";
		RM9.Tag='specmadmerc25';
		RM9 = None;
	}
	RM10=Spawn(class'RadiusMove',,,vect(-13576,12571,-2024));
	if ( RM10 != None )
	{
		RM10.RadiusRange=800;
		RM10.TimePush=2.000000;
		RM10.NamedActor="PathNode125";
		RM10.Tag='flysdaendz12';
		RM10 = None;
	}
	RM11=Spawn(class'RadiusMove',,,vect(-13513,11000,-1938));
	if ( RM11 != None )
	{
		RM11.RadiusRange=800;
		RM11.TimePush=3.000000;
		RM11.NamedActor="PathNode128";
		RM11.Tag='flysdaendz12';
		RM11 = None;
	}
	RM12=Spawn(class'RadiusMove',,,vect(-13472,10208,-1938));
	if ( RM12 != None )
	{
		RM12.RadiusRange=1850;
		RM12.TimePush=2.000000;
		RM12.NamedActor="PathNode132";
		RM12.Tag='flysdaendz12';
		RM12 = None;
	}
	RM13=Spawn(class'RadiusMove',,,vect(-13504,5792,-1938));
	if ( RM13 != None )
	{
		RM13.RadiusRange=1850;
		RM13.TimePush=3.000000;
		RM13.NamedActor="PathNode139";
		RM13.Tag='flysdaendz12';
		RM12 = None;
	}
	RM14=Spawn(class'RadiusMove',,,vect(-13488,1264,-1938));
	if ( RM14 != None )
	{
		RM14.RadiusRange=1850;
		RM14.TimePush=3.000000;
		RM14.NamedActor="PathNode146";
		RM14.Tag='flysdaendz12';
		RM14 = None;
	}
	RM15=Spawn(class'RadiusMove',,,vect(-13488,-4528,-1938));
	if ( RM15 != None )
	{
		RM15.RadiusRange=1850;
		RM15.TimePush=3.000000;
		RM15.NamedActor="PathNode153";
		RM15.Tag='flysdaendz12';
		RM15 = None;
	}
	RM16=Spawn(class'RadiusMove',,,vect(-13488,-7826,-1938));
	if ( RM16 != None )
	{
		RM16.RadiusRange=1850;
		RM16.TimePush=3.000000;
		RM16.NamedActor="PathNode156";
		RM16.Tag='flysdaendz12';
		RM16 = None;
	}
	RM17=Spawn(class'RadiusMove',,,vect(-13488,-13048,-1938));
	if ( RM17 != None )
	{
		RM17.RadiusRange=1850;
		RM17.TimePush=3.000000;
//		RM17.NamedActor="PathNode166";
		RM17.NamedActor="PathNode164";
		RM17.Tag='flysdaendz12';
		RM17 = None;
	}
	RM18=Spawn(class'RadiusMove',,,vect(-13488,-18849,-1938));
	if ( RM18 != None )
	{
		RM18.RadiusRange=1850;
		RM18.TimePush=3.000000;
		RM18.NamedActor="PathNode170";
		RM18.Tag='flysdaendz12';
		RM18 = None;
	}
	RM19=Spawn(class'RadiusMove',,,vect(-13488,-24938,-1938));
	if ( RM19 != None )
	{
		RM19.RadiusRange=1850;
		RM19.TimePush=3.000000;
		RM19.NamedActor="PathNode180";
		RM19.Tag='flysdaendz12';
		RM19 = None;
	}
	RM20=Spawn(class'RadiusMove',,,vect(-13492,-28004,-1938));
	if ( RM20 != None )
	{
		RM20.RadiusRange=950;
		RM20.TimePush=2.500000;
		RM20.NamedActor="PathNode210";
		RM20.Tag='specmadmerc25';
		RM20 = None;
	}
	RM21=Spawn(class'RadiusMove',,,vect(-13476,-30336,-1714));
	if ( RM21 != None )
	{
		RM21.RadiusRange=650;
		RM21.TimePush=2.500000;
		RM21.NamedActor="PathNode214";
		RM21.Tag='specmadmerc25';
		RM21 = None;
	}
	RM22=Spawn(class'RadiusMove',,,vect(-13488,-31554,-1622));
	if ( RM22 != None )
	{
		RM22.RadiusRange=650;
		RM22.TimePush=2.500000;
		RM22.NamedActor="PathNode218";
		RM22.Tag='madmercdead21';
		RM22 = None;
	}
	RM23=Spawn(class'RadiusMove',,,vect(-12464,-32014,-1700));
	if ( RM23 != None )
	{
		RM23.RadiusRange=1050;
		RM23.TimePush=2.500000;
		RM23.NamedActor="PathNode222";
		RM23.Tag='madmercdead21';
		RM23 = None;
	}
	RM24=Spawn(class'RadiusMove',,,vect(-10492,-31678,-1700));
	if ( RM24 != None )
	{
		RM24.RadiusRange=1000;
		RM24.TimePush=2.500000;
		RM24.NamedActor="PathNode226";
		RM24.Tag='madmercdead21';
		RM24 = None;
	}
	RM25=Spawn(class'RadiusMove',,,vect(-8380,-30390,-1700));
	if ( RM25 != None )
	{
		RM25.RadiusRange=1850;
		RM25.TimePush=2.500000;
		RM25.NamedActor="PathNode13";
		RM25.Tag='finaldoor2zip';
		RM25 = None;
	}
}

function ChangeNastyActors()
{
	local Actor A;

	foreach Level.AllActors(class 'Actor', A)
	{
//		log ("ChangeNastyActors"@A.Name);
//In order of spaming log with crap
		if ( string(A.Name) ~= "SludgeBarrel0" ) //Bullshiting mesh
		{
			A.Mesh = LodMesh'UnrealI.sbarrel';
		}
		if ( string(A.Name) ~= "BabyCow0" ) //These... Get the f..k out of Level !
		{
			A.LifeSpan = 0.5; //Timed Bomb was set - Engine will discard them properly
			Continue;
		}
		if ( string(A.Name) ~= "BabyCow1" )
		{
			A.LifeSpan = 0.5;
			Continue;
		}
		if ( string(A.Name) ~= "BabyCow2" )
		{
			A.LifeSpan = 0.5;
			Continue;
		}
		if ( string(A.Name) ~= "BabyCow3" )
		{
			A.LifeSpan = 0.5;
			Continue;
		}
		if ( string(A.Name) ~= "Bird12" ) //These... Get back in Level !
		{
			A.SetLocation(vect(-9618,-30228,-1072));
			Continue;
		}
		if ( string(A.Name) ~= "Bird14" )
		{
			A.SetLocation(vect(-9164,-30280,-776));
			Continue;
		}
		if ( string(A.Name) ~= "Bird17" )
		{
			A.SetLocation(vect(-9564,-30280,-576));
			Continue;
		}
		if ( string(A.Name) ~= "BulletBox1" )
		{
			BulletBox(A).RespawnTime = 7.000000; //Have paths - we don't make Bot busy camping there getting them forever
			BulletBox(A).MaxAmmo = BulletBox(A).Class.Default.MaxAmmo; //these were pointless screwed
/*
	If you have this weapon in hands MaxAmmmo will never go over whatb weapon says without being helped from outside
	is only a waste of time to modify these and messing up A.I. which are confused, yeah geniuses,
	you don't have any clue how do works Bots. This map was showing a lot of "how to never do"...
	has a lot of paths and none MonsterWayPoint actors.
*/
			Continue;
		}
		if ( string(A.Name) ~= "BulletBox2" )
		{
			BulletBox(A).RespawnTime = 7.000000; 
			BulletBox(A).MaxAmmo = BulletBox(A).Class.Default.MaxAmmo;
			Continue;
		}
		if ( string(A.Name) ~= "BulletBox3" )
		{
			BulletBox(A).RespawnTime = 7.000000; 
			BulletBox(A).MaxAmmo = BulletBox(A).Class.Default.MaxAmmo;
			Continue;
		}
		if ( string(A.Name) ~= "BulletBox4" )
		{
			BulletBox(A).RespawnTime = 7.000000; 
			BulletBox(A).MaxAmmo = BulletBox(A).Class.Default.MaxAmmo;
			Continue;
		}
		if ( string(A.Name) ~= "Counter11" ) //Not going to count unexistent stuff - Sh!t was removed before anyway
		{
			Counter(A).NumToCount = 3;
			Continue;
		}
		if ( string(A.Name) ~= "SteelBarrel3" )
		{
			A.Mesh = LodMesh'UnrealShare.steelbarrelM';
			Continue;
		}
		if ( string(A.Name) ~= "SteelBarrel4" )
		{
			A.Mesh = LodMesh'UnrealShare.steelbarrelM';
			Continue;
		}
		if ( string(A.Name) ~= "PrecipitationGenerator0" ) //Utter crap - a cancer
		{
			A.SetLocation(vect(-9080,-8938,-1876));
			A.SetPropertyText("CoverageY","1000"); //This is the no-spam value here
			A.SetPropertyText("CoverageX","1000");
			A.LifeSpan = 0.01; //But nah...
			log ("Precipitation Attack");
			Continue;
		}
//	Cheating is not allowed - I'm sorry
		if ( string(A.Name) ~= "Mover0" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover1" )
		{
			Mover(A).bTriggerOnceOnly = True;
			Continue;
		}
		if ( string(A.Name) ~= "Mover5" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover9" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover10" )
		{
			A.InitialState = 'StandOpenTimed';
			Continue;
		}
		if ( string(A.Name) ~= "Mover13" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover15" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover16" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover17" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover18" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover19" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover20" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover21" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover23" )
		{
			Mover(A).bUseTriggered = False;
			Mover(A).BumpType = BT_PawnBump;
			Mover(A).EncroachDamage = 100000;
			Mover(A).Event=''; //Event snipeme9 does nothing... only causing an iterator to an useless map scan :eyepoke:
			Mover(A).Tag='dropgogogo'; //and right now I open it, ahah, else is stupidly added with no usage either
			Continue;
		}
		if ( string(A.Name) ~= "Mover24" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover26" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover27" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover28" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover29" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover31" )
		{
			Mover(A).bUseTriggered = False;
//			Continue;
		}
		if ( string(A.Name) ~= "Mover32" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover35" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover36" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover37" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover40" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "AttachMover0" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover44" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover48" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover49" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover50" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover57" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover59" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover60" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover61" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover63" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover67" )
		{
			A.InitialState = 'StandOpenTimed';
			Continue;
		}
		if ( string(A.Name) ~= "Mover70" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover71" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover74" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover75" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Mover76" )
		{
			Mover(A).bUseTriggered = False;
			Continue;
		}
		if ( string(A.Name) ~= "Counter13" ) //This is useless
		{
			A.LifeSpan = 1.000000; 
			Continue;
		}
		if ( string(A.Name) ~= "SpecialEvent6" ) //Not sure if it's goning to help, those are craps...
		{
			SpecialEvent(A).Message="Escape through the acid sewer!"; //I think I have to prepare a package for download.
			Continue;
		}
		if ( string(A.Name) ~= "TeamCannon0" )
		{
			TeamCannon(A).Visibility = 200; //Now it's fun
			TeamCannon(A).MyTeam = 1;
			Continue;
		}
		if ( string(A.Name) ~= "ThingFactory0" )
		{
			ThingFactory(A).Capacity = 10; //Spam removed
			ThingFactory(A).interval = 0.25;
			Continue;
		}
		if ( string(A.Name) ~= "Trigger4" )
		{
			Trigger(A).RepeatTriggerTime = 5; //I think will skating at door went improved
			Trigger(A).ReTriggerDelay = 5;
			Continue;
		}
/*
		if ( string(A.Name) ~= "ZoneInfo2" )
		{
			HackedZone=A;
			ZoneInfo(A).bWaterZone = True;
			//Continue;
		}
*/
		if ( string(A.Name) ~= "ZoneInfo12" )
		{
			ZoneInfo(A).ZoneGroundFriction = 8.000000; //No more crap
			ZoneInfo(A).bWaterZone = True;
			Continue;
		}
		if ( string(A.Name) ~= "ZoneInfo17" )
		{
			ZoneInfo(A).ZoneGroundFriction = 8.000000; //No more crap
			ZoneInfo(A).bWaterZone = True;
			Continue;
		}
		if ( string(A.Name) ~= "ZoneInfo14" )
		{
			ZoneInfo(A).ZoneGroundFriction = 8.000000; //No more crap
			ZoneInfo(A).bWaterZone = True;
			Continue;
		}
	}
}

final function RemovePaths(NavigationPoint Evil)
{
	local Actor Start, End;
	local NavigationPoint N;
	local int distance, reachFlags, i, j;
	local bool bFound;

	for ( i=0; i<16; i++ )
	{
		Evil.Paths[i] = -1;
		if ( Evil.UpstreamPaths[i] != -1 )
		{
			Evil.DescribeSpec( Evil.Paths[i], Start, End, reachFlags, distance );
			bFound = false;
			N = NavigationPoint(Start);
			if ( N != None )
			{
				for ( j=0; j<15; j++ )
				{
					if ( !bFound )
					{
						Evil.DescribeSpec(N.Paths[j], Start, End, reachFlags, distance);
						bFound = ( End == Evil );
					}
					if ( bFound )
						N.Paths[j] = N.Paths[j+1];
				}
				N.Paths[15] = -1;
			}
			Evil.UpstreamPaths[i] = -1;
		}
	}

}

final function SpawnPaths()
{
	local Actor tmp;
	local NavigationPoint M1, M2;

	Spawn(class'SmartNode',,,vect(-9120,8952,-2958)); //1
/*
ScriptToCopy: Spawn(class'SmartNode',,,vect(-754,-3,-225));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-968,241,-214));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1262,230,-225));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1275,-33,-227));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1539,-57,-226));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1719,-55,-226));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1863,-91,-199));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1834,-264,-46));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2013,-363,-37));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2131,-338,65));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2308,-229,116));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2340,-91,241));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2257,47,287));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2246,324,279));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2182,553,285));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-2111,290,254));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1932,282,257));
ScriptToCopy: Spawn(class'SmartNode',,,vect(-1830,279,279));
*/
	M1 = Spawn(class'SmartNode',,,vect(-754,-3,-225)); //2
	M2 = Spawn(class'SmartNode',,,vect(-968,241,-214)); //3
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M2,M1 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
//	Location: -820 -37 -243
	M2 = Spawn(class'SmartNode',,,vect(-1262,230,-225)); //4
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M2,M1 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1275,-33,-227)); //5
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M2,M1 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1539,-57,-226)); //6
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M2,M1 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1719,-55,-226)); //7
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	spawn(class'AltBlock',,,vect(-1653, -55, -298));
	M2 = Spawn(class'SmartNode',,,vect(-1863,-91,-199)); //8 - falling
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1834,-264,-46)); //9
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2013,-363,-37)); //10
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2131,-338,65)); //11
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}

	M2 = Spawn(class'SmartNode',,,vect(-2308,-229,116)); //12
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2340,-91,241)); //13
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}

	M2 = Spawn(class'SmartNode',,,vect(-2257,47,287)); //14
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2246,324,279)); //15
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2182,553,285)); //16
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-2111,290,254)); //17
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1932,282,257)); //18
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
//		M1 = M2;
		M2 = None;
	}
/*
	M2 = Spawn(class'SmartNode',,,vect(-1815,277,266)); //19
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1419,290,272)); //20
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-1167,356,275)); //21
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-958,340,250)); //22
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-737,426,104)); //23
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M1 = M2;
		M2 = None;
	}
	M2 = Spawn(class'SmartNode',,,vect(-354,336,-184)); //24
	if ( M1 != None && M2 != None )
	{
		if ( G != None )
		{
			G.EzConnectNavigationPoints( M1,M2 );
		}
		M1 = None;
		M2 = None;
	}
*/
// PathsActor will connect later these
	if ( G != None )
	{
		G.EzConnectNavigationPoints( N1,N2,,True );
		log ("Connected"@N1.Name@"and"@N2.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N3,N4,,True );
		log ("Connected"@N3.Name@"and"@N4.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N5,N6,,True );
		log ("Connected"@N5.Name@"and"@N6.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N7,N8,,True );
		log ("Connected"@N7.Name@"and"@N8.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N9,N10,,True );
		log ("Connected"@N9.Name@"and"@N10.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N11,N12,,True );
		log ("Connected"@N11.Name@"and"@N12.Name,'BirdBrainedResearch');
		G.EzConnectNavigationPoints( N13,N14,,True );
		log ("Connected"@N13.Name@"and"@N14.Name,'BirdBrainedResearch');
	}
//	ConsoleCommand("SET LIFTEXIT BSTATIC 1");
//	ConsoleCommand("SET PATHNODE BSTATIC 1");
//	ConsoleCommand("SET ENGINE.TELEPORTER BSTATIC 1");
//	ConsoleCommand("SET INVENTORYSPOT BSTATIC 1");
	N1 = None;
	N2 = None;
	N3 = None;
	N4 = None;
	N5 = None;
	N6 = None;
	N7 = None;
	N8 = None;
	N9 = None;
	N10 = None;
	N11 = None;
	N12 = None;
	N13 = None;
	N14 = None;
// Connected some points

	Spawn(class'FSmartNode',,,vect(-13496,-31702,-1830));
	Spawn(class'SmartNode',,,vect(-11628,-32020,-1824));
	Spawn(class'SmartNode',,,vect(-13146,-32018,-1828));
//	Spawn(class'SmartNode',,,vect(-13458,11664,-1986)); //Eh I forgot something here which I had in mind...
	spawn(class'AltBlock',,,vect(336,-569,-144)).SetCollisionSize(44,44); //Cover these blocked paths - Engine will no longer allow seeking here
	spawn(class'AltBlock',,,vect(-90,596,-198)).SetCollisionSize(44,44);
	spawn(class'AltBlock',,,vect(290,600,-198)).SetCollisionSize(44,44);
	spawn(class'AltBlock',,,vect(142,-582,-198)).SetCollisionSize(44,44);
	Spawn(class'AltBlock',,,vect(-820,-37,-243)).SetCollisionSize(44,44); //BT issues
	Spawn(class'AltBlock',,,vect(-1238,-16,-295)).SetCollisionSize(20,20);
	spawn(class'AltBlock',,,vect(-8561,7056,-3022)).SetCollisionSize(20,20); //Against direct fall - I forgot that bad occurrence
	spawn(class'E_BlockAll',,,vect(784,480,-1218)).SetCollisionSize(190,30); //Not gona use any TriggeredDeath thanks to Epic, so get a break with craps, this will cover that hole	spawn(class'E_BlockAll',,,vect(784,480,-1218)).SetCollisionSize(190,30); //Not gona use any TriggeredDeath thanks to Epic, so get a break with craps, this will cover that hole
	spawn(class'E_BlockAll',,,vect(16816,-4928,-2976)).SetCollisionSize(60,4); 
	spawn(class'E_BlockAll',,,vect(16912,-4928,-2976)).SetCollisionSize(60,4); 
	spawn(class'E_BlockAll',,,vect(17008,-4800,-3000)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17632,-4672,-3280)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17552,-4864,-3304)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17560,-5072,-3312)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17800,-5072,-3312)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17584,-6816,-2992)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17584,-7104,-3248)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17656,-7224,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17720,-7320,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17768,-7416,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17800,-7528,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17800,-7624,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17800,-7736,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17832,-7816,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17880,-8008,-3240)).SetCollisionSize(60,4);
	spawn(class'E_BlockAll',,,vect(17880,-8096,-3240)).SetCollisionSize(110,4);
	spawn(class'E_BlockAll',,,vect(17520,-8416,-2936)).SetCollisionSize(120,4);

}

function RestoreOriginal()
{
	local Actor A;

	foreach AllActors(class 'Actor', A)
	{
		if ( String(A.Name) ~= "SludgeBarrel0" ) //Bullshiting mesh
		{
			A.Mesh = LodMesh'Botpack.BRifle2Pick';
			//Continue;
		}
		if ( String(A.Name) ~= "SteelBarrel3" )
		{
			A.Mesh = LodMesh'UnrealShare.WoodenBoxM';
			//Continue;
		}
		if ( String(A.Name) ~= "SteelBarrel4" )
		{
			A.Mesh = LodMesh'UnrealShare.WoodenBoxM';
			//Continue;
		}
	}
}

function DoReconnect()
{
	local NavigationPoint N;
	local ZoneInfo Z;

	Foreach AllActors(class'ZoneInfo',Z)
	{
		if (string(Z.name) ~= "ZoneInfo12")
		{
			foreach Z.ZoneActors(class'NavigationPoint',N)
			{
				if ( G != None )
					G.SimpleConnect( N );
			}
			Z.bWaterZone = False;
			//Continue;
		}
		if (string(Z.name) ~= "ZoneInfo17")
		{
			foreach Z.ZoneActors(class'NavigationPoint',N)
			{
				if ( G != None )
					G.SimpleConnect( N );
			}
			Z.bWaterZone = False;
			//Continue;
		}
		if (string(Z.name) ~= "ZoneInfo14")
		{
			Z.bWaterZone = False;
			//Continue;
		}
	}
}

auto state PathsMapping
{
Begin:
	Sleep(0.2);
	log ("Navigation processing done, spawning new paths...",'BirdBrainedResearch');
	SpawnPaths();
	Spawn(class'SomeActor');
	Sleep(0.0);
	DoFakeNavigation();
//	HackedZone.SetPropertyText("bWaterZone","False");
Sleep(0.5);
	DoReconnect();
	Spawn(class'TelPathsHacker');
	RestoreOriginal();
	GotoState('');
}

defaultproperties
{
	bMovable=False
	bStatic=False
	bGameRelevant=True
}
